package com.hfkj.dao;

import com.hfkj.entity.BsAgentMerAccountRecord;
import com.hfkj.entity.BsAgentMerAccountRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsAgentMerAccountRecordMapper extends BsAgentMerAccountRecordMapperExt {
    @SelectProvider(type=BsAgentMerAccountRecordSqlProvider.class, method="countByExample")
    long countByExample(BsAgentMerAccountRecordExample example);

    @DeleteProvider(type=BsAgentMerAccountRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsAgentMerAccountRecordExample example);

    @Delete({
        "delete from bs_agent_mer_account_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_agent_mer_account_record (agent_mer_account_id, agent_id, ",
        "mer_no, `type`, transaction_amount, ",
        "before_amount, after_amount, ",
        "source_type, source_id, ",
        "source_order_no, source_content, ",
        "`status`, create_time, ",
        "op_user_type, op_user_id, ",
        "op_user_name, op_user_phone, ",
        "ext_1, ext_2, ext_3)",
        "values (#{agentMerAccountId,jdbcType=BIGINT}, #{agentId,jdbcType=BIGINT}, ",
        "#{merNo,jdbcType=VARCHAR}, #{type,jdbcType=INTEGER}, #{transactionAmount,jdbcType=DECIMAL}, ",
        "#{beforeAmount,jdbcType=DECIMAL}, #{afterAmount,jdbcType=DECIMAL}, ",
        "#{sourceType,jdbcType=INTEGER}, #{sourceId,jdbcType=BIGINT}, ",
        "#{sourceOrderNo,jdbcType=VARCHAR}, #{sourceContent,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{opUserType,jdbcType=INTEGER}, #{opUserId,jdbcType=BIGINT}, ",
        "#{opUserName,jdbcType=VARCHAR}, #{opUserPhone,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsAgentMerAccountRecord record);

    @InsertProvider(type=BsAgentMerAccountRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsAgentMerAccountRecord record);

    @SelectProvider(type=BsAgentMerAccountRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="agent_mer_account_id", property="agentMerAccountId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="transaction_amount", property="transactionAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="before_amount", property="beforeAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="after_amount", property="afterAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="source_order_no", property="sourceOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="source_content", property="sourceContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_user_type", property="opUserType", jdbcType=JdbcType.INTEGER),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="op_user_phone", property="opUserPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsAgentMerAccountRecord> selectByExample(BsAgentMerAccountRecordExample example);

    @Select({
        "select",
        "id, agent_mer_account_id, agent_id, mer_no, `type`, transaction_amount, before_amount, ",
        "after_amount, source_type, source_id, source_order_no, source_content, `status`, ",
        "create_time, op_user_type, op_user_id, op_user_name, op_user_phone, ext_1, ext_2, ",
        "ext_3",
        "from bs_agent_mer_account_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="agent_mer_account_id", property="agentMerAccountId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="transaction_amount", property="transactionAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="before_amount", property="beforeAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="after_amount", property="afterAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="source_order_no", property="sourceOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="source_content", property="sourceContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_user_type", property="opUserType", jdbcType=JdbcType.INTEGER),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="op_user_phone", property="opUserPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsAgentMerAccountRecord selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsAgentMerAccountRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsAgentMerAccountRecord record, @Param("example") BsAgentMerAccountRecordExample example);

    @UpdateProvider(type=BsAgentMerAccountRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsAgentMerAccountRecord record, @Param("example") BsAgentMerAccountRecordExample example);

    @UpdateProvider(type=BsAgentMerAccountRecordSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsAgentMerAccountRecord record);

    @Update({
        "update bs_agent_mer_account_record",
        "set agent_mer_account_id = #{agentMerAccountId,jdbcType=BIGINT},",
          "agent_id = #{agentId,jdbcType=BIGINT},",
          "mer_no = #{merNo,jdbcType=VARCHAR},",
          "`type` = #{type,jdbcType=INTEGER},",
          "transaction_amount = #{transactionAmount,jdbcType=DECIMAL},",
          "before_amount = #{beforeAmount,jdbcType=DECIMAL},",
          "after_amount = #{afterAmount,jdbcType=DECIMAL},",
          "source_type = #{sourceType,jdbcType=INTEGER},",
          "source_id = #{sourceId,jdbcType=BIGINT},",
          "source_order_no = #{sourceOrderNo,jdbcType=VARCHAR},",
          "source_content = #{sourceContent,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "op_user_type = #{opUserType,jdbcType=INTEGER},",
          "op_user_id = #{opUserId,jdbcType=BIGINT},",
          "op_user_name = #{opUserName,jdbcType=VARCHAR},",
          "op_user_phone = #{opUserPhone,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsAgentMerAccountRecord record);
}